﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private Mdl As Short
	Private Center, Scale As Double
	Private Radius As Double
	Private tDiam As Double 
	Private Bolt As JavaObject
	Private Typ As JavaObject
	Private SList(2) As List
	Private Stp0(3) As JavaObject 
	Private RadialGradient As JavaObject 
	Private LinearGradient As JavaObject 
	Private Shadow As JavaObject 
	Private Light As JavaObject 
	Private Lighting As JavaObject 
End Sub

'Diam = Diameter of the screw head
'Model = 
	'0 = Round head slotted screw.
	'1 = Round head Philips screw.
	'2 = Round head Allen screw.
	'3 = Flat head slotted screw.
	'4 = Flat head Philips screw.
	'5 = Flat head Allen screw.
	'6 = Hex head screw.
Public Sub Initialize(Diam As Double, Model As Short)
	Mdl = Max(Min(Model,6),0)
	tDiam = Diam
	pnMain.Initialize("")
	pnMain.PrefHeight = tDiam
	pnMain.PrefWidth = tDiam
	SList(0).Initialize
	SList(1).Initialize 
	makeBolt
End Sub

Public Sub Show(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
End Sub

Private Sub makeBolt
	Scale = 60 / tDiam
	Radius = tDiam / 2
	Center = tDiam / 2
	Select Case Mdl
		Case 0
			Model_0
		Case 1
			Model_1
		Case 2
			Model_2		
		Case 3
			Model_3		
		Case 4
			Model_4		
		Case 5
			Model_5		
		Case 6
			Model_6		
	End Select
	pnMain.AddNode(Bolt,-1, -1, -1, -1)
	pnMain.AddNode(Typ,-1, -1, -1, -1)
End Sub

Private Sub Model_6
	MakeHexHead
	MakeCircle
End Sub

Private Sub Model_5
	MakeFlatHead
	MakeAllen
End Sub

Private Sub Model_4
	MakeFlatHead
	MakePhilips	
End Sub

Private Sub Model_3
	MakeFlatHead
	MakeSlotted	
End Sub

Private Sub Model_2
	MakeRoundHead
	MakeAllen
End Sub

Private Sub Model_1
	MakeRoundHead
	MakePhilips
End Sub

Private Sub Model_0
	MakeRoundHead
	MakeSlotted
End Sub

Private Sub MakeHexHead
	Dim NewPt(12) As Double
	Dim nPt As PointApi
	Dim CountPt As Short = -1
	Dim Angle As Double
	Dim ini As Short = Rnd(0,60)
	For i = ini To 359 Step 60
		Angle = i'*60
		nPt= new_pt(Angle,Radius,Center,Center)
		CountPt=CountPt + 1
		NewPt(CountPt) = nPt.X
		CountPt=CountPt + 1
		NewPt(CountPt) = nPt.Y
	Next
	Bolt.InitializeNewInstance("javafx.scene.shape.Polygon",Array(NewPt))
	Bolt.RunMethod("setFill",Array(fx.Colors.RGB(190,190,190)))
	makeLighting
	Bolt.RunMethod("setEffect",Array (Lighting))
End Sub

Private Sub MakeRoundHead
	Bolt.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	makeRadialGradient
	Bolt.RunMethod("setFill", Array(RadialGradient))
	Bolt.RunMethod("setStrokeWidth",Array (0.0))
End Sub

Private Sub MakeFlatHead
	Bolt.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	Bolt.RunMethod("setStrokeWidth",Array (0.0))
	Bolt.RunMethod("setFill",Array(fx.Colors.RGB(190,190,190)))
	'******** creates Shadow effect
	makeLighting
	Bolt.RunMethod("setEffect",Array(Lighting))
End Sub

Private Sub makeLinearGradient
	Stp0(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(32, 32, 32)))
	Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.5, fx.Colors.RGB(128, 128, 128)))
	Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(255, 255, 255)))
	SList(0).Clear 
	SList(0).Add(Stp0(0))
	SList(0).Add(Stp0(1))
	SList(0).Add(Stp0(2))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(0.0, 1.0, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList(0)))
End Sub

Private Sub makeRadialGradient
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	Stp0(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(235, 235, 235)))
	Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.5, fx.Colors.RGB(135, 135, 135)))
	Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(235, 235, 235)))
	SList(0).Clear 
	For i = 0 To 2
		SList(0).Add(Stp0(i))
	Next	
	RadialGradient.InitializeNewInstance("javafx.scene.paint.RadialGradient", Array(0.0, 0.0, 0.300552, 0.372037,0.94, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList(0)))
End Sub

Private Sub makeLighting
	Shadow.InitializeNewInstance("javafx.scene.effect.Shadow",Null)
	Shadow.RunMethod("setColor",Array(fx.Colors.ARGB(200,0,0,0)))
	Shadow.RunMethod("setHeight",Array(11.0/Scale))
	Shadow.RunMethod("setWidth",Array(11.0/Scale))
	Shadow.RunMethod("setRadius",Array(5.0/Scale))
	
	'******** creates Light.Distant effect
	Light.InitializeNewInstance("javafx.scene.effect.Light.Distant",Null)
	Light.RunMethod("setColor",Array(fx.Colors.ARGB(255,255,255,255)))
	Light.RunMethod("setAzimuth",Array(235.0))
	Light.RunMethod("setElevation",Array(45.0))
	
	'******** creates Lighting effect
	Lighting.InitializeNewInstance("javafx.scene.effect.Lighting",Null)
	Lighting.RunMethod("setDiffuseConstant",Array(0.98))
	Lighting.RunMethod("setSpecularConstant",Array(0.83))
	Lighting.RunMethod("setSpecularExponent",Array(16.38))
	Lighting.RunMethod("setSurfaceScale",Array(3.23))
	Lighting.RunMethod("setBumpInput",Array(Shadow))
	Lighting.RunMethod("setLight",Array(Light))
End Sub

Private Sub makeLighting1

	'******** creates Light.Distant effect
	Light.InitializeNewInstance("javafx.scene.effect.Light.Distant",Null)
	Light.RunMethod("setColor",Array(fx.Colors.ARGB(255,224,224,224)))
	Light.RunMethod("setAzimuth",Array(45.0))
	Light.RunMethod("setElevation",Array(45.0))
	
	'******** creates Lighting effect
	Lighting.InitializeNewInstance("javafx.scene.effect.Lighting",Null)
	Lighting.RunMethod("setDiffuseConstant",Array(1.0))
	Lighting.RunMethod("setSpecularConstant",Array(0.6))
	Lighting.RunMethod("setSpecularExponent",Array(15.0))
	Lighting.RunMethod("setSurfaceScale",Array(1.0))
	Lighting.RunMethod("setLight",Array(Light))
End Sub

Private Sub MakeCircle
	Radius = Radius - 14/Scale
	Typ.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	Typ.RunMethod("setFill",Array(fx.Colors.Transparent))
	Typ.RunMethod("setStrokeWidth",Array (1.0/Scale))
	makeLinearGradient
	Typ.RunMethod("setStroke", Array(LinearGradient))	
End Sub

Private Sub MakePhilips
	Dim Angle As Double = Rnd(0,90)
	Dim Compens As Double = 14'/Scale
	Radius = Radius - 12 / Scale
	Dim Radius1 As Double = newFace(Compens, Radius, Radius)
	Dim NewPt(24) As Double
	Dim nPt As PointApi
	Dim p As Int
	For i = 0 To 3
		p = i*6
		nPt = new_pt(Angle-Compens,Radius,Center,Center)
		NewPt(p) = nPt.X 
		NewPt(p+1) = nPt.y
		
		nPt = new_pt(Angle+Compens,Radius,Center,Center)
		NewPt(p+2)=nPt.X 
		NewPt(p+3)=nPt.y

		nPt = new_pt((Angle)-180,Radius-Radius1,nPt.X,nPt.y)
		NewPt(p+4)=nPt.X 
		NewPt(p+5)=nPt.y	
		Angle=Angle + 90
	Next
	Typ.InitializeNewInstance("javafx.scene.shape.Polygon",Array(NewPt))
	makeLinearGradient
	Typ.RunMethod("setFill", Array(LinearGradient))	
	makeLighting1
	Typ.RunMethod("setEffect",Array (Lighting))
	Typ.RunMethod("setStrokeWidth",Array (0.0))
End Sub

Private Sub MakeAllen
	Dim NewPt(12) As Double
	Dim nPt As PointApi
	Dim CountPt As Short = -1
	Radius = Radius -14/Scale
	Dim Angle As Double
	Dim ini As Short = Rnd(0,60)
	For i = ini To 359 Step 60
		Angle=i'*60
		nPt= new_pt(Angle,Radius,Center,Center)
		CountPt=CountPt + 1
		NewPt(CountPt)=nPt.X
		CountPt=CountPt + 1
		NewPt(CountPt) = nPt.Y
	Next
	Typ.InitializeNewInstance("javafx.scene.shape.Polygon",Array(NewPt))
	makeLinearGradient
	Typ.RunMethod("setFill", Array(LinearGradient))
	Typ.RunMethod("setStrokeWidth",Array (0.0))	
	makeLighting1
	Typ.RunMethod("setEffect",Array (Lighting))
End Sub

Private Sub MakeSlotted
	Dim Angle As Double = Rnd(-89, 91)
	Dim Compens As Double = 10
	Dim NewPt(8) As Double
	Radius = Radius - 4/Scale
	Dim nPt As PointApi
	Dim p As Int
	For i = 0 To 1
		p = i*4
		nPt = new_pt(Angle-Compens,Radius,Center,Center)
		NewPt(p) = nPt.X 
		NewPt(p+1) = nPt.y
		
		nPt = new_pt(Angle+Compens,Radius,Center,Center)
		NewPt(p+2)=nPt.X 
		NewPt(p+3)=nPt.y
		Angle=Angle + 180
	Next
	Typ.InitializeNewInstance("javafx.scene.shape.Polygon",Array(NewPt))
	makeLinearGradient
	Typ.RunMethod("setFill", Array(LinearGradient))	
End Sub

Private Sub new_pt(nAngle As Double, r As Double, CX  As Double, CY As Double ) As PointApi 
    Dim AngleRad As Double
	Dim pt As PointApi 
	nAngle = 90 + nAngle
    If nAngle > 360 Then nAngle = nAngle - 360
    AngleRad = nAngle * cPI / 180 'convert to rad
    If AngleRad < 0 Then AngleRad = 6.283 + AngleRad
    pt.x = CX + (r) * Cos(AngleRad)
    pt.Y  = CY - (r) * Sin(AngleRad)
    Return pt
End Sub

Private Sub newFace(Ang As Double,face1 As Double, face2 As Double)  As Double
	Dim k1 As Double = face1
	Dim k2 As Double = Ang
	Dim k3 As Double = face2
	Dim a1 As Double	'=0.0174532925199433
	Dim a2 As Double 	'=57.2957795130823
	Dim a3 As Double 	'=3.14159265358979
	Dim a4 As Double
	Dim cnvangin As Double = 0.0174532925199433
	Dim cnvangout As Double = 57.2957795130823
	Dim h, x, y As Double
	k2 = (k2 * cnvangin)
	h = k1 * Sin(k2)
	x = k1 * Cos(k2)
	y = (k3 - x)
	a1 = ATan(h / y)
	If (a1 < 0) Then a1 = a1 + cPI
	If (a1 > cPI) Then a1 = a1 - cPI
	a3 = cPI - a1 - k2
	a1 = a1 * cnvangout	'angulo oposto
	a2 = Sqrt(h * h + y * y) 'igual ao lado oposto
	a3 = a3 * cnvangout	'angulo oposto
	a4 = (h * k3) / 2	'Area
	Return a2
End Sub