﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private Scale As Double
	Private tHght, tWdth As Double 	
	Private pnPanel As JavaObject 
	Private pnBack As JavaObject 
	Private txt As JavaObject 
	Private ClrT As Short
	Private SList As List
	Private imgOn, imgOff As Image
	Private imSwt As ImageView 
	Private Part(2) As JavaObject 
	Private Clr(2) As Paint
	Private swtOn As Boolean =False
	Private Play As AudioClip
	Private isEnabled As Boolean 
	Private CallBack As Object
End Sub

'Hght = Switch height.
'The width Is automatically = height / 2.
'ClrType = Switch Color
	'0 = Red
	'1 = Green
	'2 = Yellow
	'3 = Blue
	'4 = Gray
Public Sub Initialize(CBack As Object, Hght As Double, ClrType As Short)
	CallBack = CBack 
	ClrT = Max(Min(ClrType, 4), 0)
	tHght = Hght
	tWdth = tHght / 2
	Scale = 105 / tHght
	pnMain.Initialize("")
	pnMain.PrefHeight = tHght
	pnMain.PrefWidth = tWdth
	imSwt.Initialize("imSwt")
	SList.Initialize
	isEnabled = True
	Play.Initialize(File.GetUri(File.DirAssets, "Switch.mp3"))
	makeSwitch
End Sub

Public Sub Show(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(imSwt, lft, Tp, -1, -1)
End Sub

Public Sub isOn As Boolean 
	Return swtOn
End Sub

Public Sub Enabled(Enbld As Boolean )
	If Not(Enbld) Then
		imSwt.Alpha = 0.5
	Else
		imSwt.Alpha = 1
	End If
	isEnabled = Enbld
	imSwt.Enabled = isEnabled
End Sub

Public Sub TurnOn(sOn As Boolean)
	If sOn = swtOn Then Return
	changeOn
End Sub

Private Sub makeSwitch
	pnPanel.InitializeNewInstance("javafx.scene.shape.Rectangle", Array (tWdth, tHght))	
	Dim strkWdt As Double = 4 / Scale
	
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeType")
	pnPanel.RunMethod("setStrokeType",Array As Object(JO.RunMethod("valueOf",Array("INSIDE"))))
	
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	pnPanel.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	pnPanel.RunMethod("setStrokeWidth",Array (strkWdt))

	Dim Stp(3) As JavaObject 
	Dim RadialGradient As JavaObject 
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(97, 96, 96)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(97, 97, 97)))
	Stp(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(213, 213, 213)))
	For i = 0 To 2
		SList.Add(Stp(i))
	Next	
	RadialGradient.InitializeNewInstance("javafx.scene.paint.RadialGradient", Array(0.0, 0.0, 0.25, 0.335,0.51, True,JO.RunMethod("valueOf",Array As Object ("REFLECT")),SList))
	pnPanel.RunMethod("setStroke", Array(RadialGradient))	
	pnPanel.RunMethod("setFill", Array(fx.Colors.RGB(84, 84, 84)))
	pnMain.AddNode(pnPanel,-1, -1, -1, -1)
	Select Case ClrT
		Case 0	'Red
			Clr(0) = fx.Colors.RGB(174, 12, 12)
			Clr(1) = fx.Colors.RGB(204, 142, 142) 
		Case 1	'Green
			Clr(0) = fx.Colors.RGB(10, 138, 56)
			Clr(1) = fx.Colors.RGB(147, 210, 154) 
		Case 2	'Yellow
			Clr(0) = fx.Colors.RGB(160, 160, 0)
			Clr(1) = fx.Colors.RGB(250, 250, 120) 
		Case 3	'Blue
			Clr(0) = fx.Colors.RGB(0, 60, 100)
			Clr(1) = fx.Colors.RGB(130, 180, 230) 
		Case 4	'Gray
			Clr(0) = fx.Colors.RGB(70, 70, 70)
			Clr(1) = fx.Colors.RGB(230, 230, 230) 
	End Select
	pnBack.InitializeNewInstance("javafx.scene.shape.Rectangle", Array (tWdth-12/Scale, tHght-12/Scale))	
	pnBack.RunMethod("setStrokeWidth",Array (0.0))
	pnBack.RunMethod("setFill", Array(Clr(1)))
	pnMain.AddNode(pnBack,6/Scale, 6/Scale, -1, -1)
	
	Dim Points(8) As Double
	Points(0) = 6 / Scale 
	Points(1) = 6 / Scale
	Points(2) = tWdth - 6 / Scale
	Points(3) = 6 / Scale
	Points(4) = tWdth - 9 /Scale
	Points(5) = (18 / Scale) + (6 / Scale) 
	Points(6) = 9 / Scale
	Points(7) = (18 / Scale) + (6 / Scale) 
	
	Part(0).InitializeNewInstance("javafx.scene.shape.Polygon",Array(Points))
	
	'******** creates LinearGradient effect
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, Clr(1)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, Clr(0)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(1.0, 0.0, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList))
	Part(0).RunMethod("setFill", Array(LinearGradient))
	pnMain.AddNode(Part(0),-1, -1, -1, -1)
	
	Points(0) = 6 / Scale 
	Points(1) = tHght - 6 / Scale
	Points(2) = 9 / Scale
	Points(3) = tHght - (79 / Scale)
	Points(4) = tWdth - 9 / Scale
	Points(5) = tHght - (79 / Scale) 
	Points(6) =  tWdth - 6 / Scale
	Points(7) = tHght - 6 / Scale
	Part(1).InitializeNewInstance("javafx.scene.shape.Polygon",Array(Points))	
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, Clr(0)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, Clr(1)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(1.0, 0.0, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList))
	Part(1).RunMethod("setFill", Array(LinearGradient))
	pnMain.AddNode(Part(1),-1, -1, -1, -1)	
	Dim f As Font = fx.CreateFont("System", 14/Scale,True,False)
	txt.InitializeNewInstance("javafx.scene.text.Text", Array( 15 / Scale, 19 / Scale, "ON"))
	txt.RunMethod("setFont", Array(f))
	txt.RunMethod("setFill", Array(Clr(1)))
	txt.RunMethod("setScaleY",Array(0.75))
	pnMain.AddNode(txt,-1, -1, -1, -1)
	imgOff=pnMain.Snapshot 
	
	imSwt.SetImage(imgOff) 
	'imswt.Style="-fx-rotate: 90;"
	pnMain.RemoveAllNodes 
	pnMain.AddNode(pnPanel,-1, -1, -1, -1)
	pnMain.AddNode(pnBack,6/Scale, 6/Scale, -1, -1)
	
	Dim nPoints(8) As Object
	nPoints(0) = 6 / Scale 
	nPoints(1) = 6 / Scale
	nPoints(2) = tWdth -6 / Scale
	nPoints(3) = 6 / Scale
	nPoints(4) = tWdth - 9 / Scale
	nPoints(5) = (73 / Scale) + (6 / Scale) 
	nPoints(6) = 9 / Scale
	nPoints(7) = (73 / Scale) + (6 / Scale) 
	ReDefinePoly(Part(0), nPoints)
	pnMain.AddNode(Part(0), -1, -1, -1, -1)
	
	nPoints(0) = 6 / Scale 
	nPoints(1) = tHght - 6 / Scale
	nPoints(2) = 9 / Scale
	nPoints(3) = tHght - (24 / Scale)
	nPoints(4) = tWdth - 9 / Scale
	nPoints(5) = tHght - (24 / Scale) 
	nPoints(6) = tWdth - 6 / Scale
	nPoints(7) = tHght - 6 / Scale	
	ReDefinePoly(Part(1), nPoints)
	pnMain.AddNode(Part(1), -1, -1, -1, -1)	
	txt.RunMethod("setText", Array("OFF"))
	txt.RunMethod("setX",Array(12 / Scale))
	txt.RunMethod("setY",Array(tHght - 10 / Scale))
	pnMain.AddNode(txt,-1, -1, -1, -1)
	imgOn = pnMain.Snapshot 	
End Sub

Private Sub imSwt_MouseClicked (EventData As MouseEvent)
	If Not(isEnabled) Then Return
	Dim idx As Short  = pnMain.tag
	Dim rOn As Boolean = Not(swtOn)
	CallSub3(CallBack, "Swt_MouseClicked", idx, rOn)
	Play.Play
	changeOn
End Sub

Private Sub changeOn 
	If swtOn Then
		imSwt.SetImage(imgOff) 
	Else
		imSwt.SetImage(imgOn)
	End If
	swtOn = Not(swtOn)
End Sub

Public Sub STag(tg As Object)
	pnMain.Tag = tg
End Sub

Public Sub GTag(tg As Object)
	Return pnMain.Tag
End Sub

Private Sub ReDefinePoly(Poly As Node,NewPoints() As Object) As Boolean
        Dim Points As JavaObject
        Dim PO As JavaObject = Poly
        Points = PO.RunMethod("getPoints", Null)
        'Removes all points and adds new ones
        Return(Points.RunMethod("setAll",Array As Object(NewPoints)))
End Sub